@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!/sw/bin/perl
#line 14

# Usage: splitpmpod <file> [<file> ...]

$self = $0;
$self =~ s!^.*[/\\]!!;

FILE:
foreach $file (map( glob($_), @ARGV ))
{
    next FILE unless (-f $file);
    unless (open(ORIG, "<$file"))
    {
        warn "$self: unable to read '$file': $!\n";
        next FILE;
    }
    $base = $file;
    unless ($base =~ s!\.+orig$!!)
    {
        unless (rename($file,"$file.orig"))
        {
            warn "$self: unable to rename '$file' to '$file.orig': $!\n";
            next FILE;
        }
        $file .= ".orig";
    }
    $base =~ s!\.+[^\.]*$!!;
    unless (open(POD, ">$base.pod"))
    {
        warn "$self: unable to write '$base.pod': $!\n";
        close(ORIG);
        next FILE;
    }
    unless (open(PM, ">$base.pm"))
    {
        warn "$self: unable to write '$base.pm': $!\n";
        close(ORIG);
        close(POD);
        next FILE;
    }
    $flag = 0;
    while (defined ($line = <ORIG>))
    {
        if ($line =~ /^=([a-zA-Z]+\d*)\b/)
        {
            if    ($1 eq 'cut') { $flag = 0; }
            elsif ($1 eq 'pod') { $flag = 1; }
            else
            {
                $flag = 1;
                print POD $line;
            }
        }
        else
        {
            if ($flag) { print POD $line; }
            else       { print PM  $line; }
        }
    }
    unless (close(ORIG))
    {
        warn "$self: unable to close '$file': $!\n";
    }
    unless (close(POD))
    {
        warn "$self: unable to close '$base.pod': $!\n";
    }
    unless (close(PM))
    {
        warn "$self: unable to close '$base.pm': $!\n";
    }
}

__END__

__END__
:endofperl
